#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{
    int w,h,r,q,b,x=0,y=0,xl,j=0;
    scanf("%d%d%d%d",&w,&h,&r,&q);
    double d[q];
    for(int i=0 ; i<q ; ++i){
          scanf("%d",&b);

          if(b==1){
               scanf("%d%d",&x,&y );
          }

          else if(b==2) {

               scanf("%d",&xl);

               if(y-h >= r || x-w >= r || y==0 || x==0 || (xl<x && r<=x-xl)){
                    d[j]=h*1.00;
               }
               else{
                    d[j]=y-sqrt(r*r-pow(x-xl,2));
               }
          ++j;
          }
    }
    for(int i=0;i<j;++i)
           printf("%.12f \n",d[i]);
    return 0;
}